using System;

//	LowLevel
//	LowLevel auxiliar logical functions
//	(c) Jordi Bartolome 2004
//	www.tolaemon.com

namespace LowLevel
{
	/// <summary>
	/// ConversionFunction Class by J.Bartolome (Tolaemon) 30-3-04
	/// This class contains methods refered to lowlevel types conversion: word, byte, nible in HEX, DEC and BIANRY representations
	/// </summary>
	public class ConversionFunctions{

		public ConversionFunctions(){
			//
			// Constructor
			//
		}
	
		//This function recives a char with an hexadecimal digit and returns its value.
		public int NibleHexToNat(char NibleHex){
			int NibleNat=0;
			
			//NibleNat takes its value depending on aux_char digit
			switch (NibleHex){
				case '0':
					NibleNat=0;
					break;
				case '1':
					NibleNat=1;
					break;
				case '2':
					NibleNat=2;
					break;
				case '3':
					NibleNat=3;
					break;
				case '4':
					NibleNat=4;
					break;
				case '5':
					NibleNat=5;
					break;
				case '6':
					NibleNat=6;
					break;
				case '7':
					NibleNat=7;
					break;
				case '8':
					NibleNat=8;
					break;
				case '9':
					NibleNat=9;
					break;
				case 'A':
					NibleNat=10;
					break;
				case 'B':
					NibleNat=11;
					break;
				case 'C':
					NibleNat=12;
					break;
				case 'D':
					NibleNat=13;
					break;
				case 'E':
					NibleNat=14;
					break;
				case 'F':
					NibleNat=15;
					break;
				default:
					NibleNat=0;
					break;
			};//switch
			
			return NibleNat;

		}//NibleHexToNat


		//This function recives a natural value and retruns it's hexadecimal nible representation
		public char NatToNibleHex(int nat){
			char nible_hex=' ';
			
			//NibleHex takes its value depending on nat value
			switch (nat){
				case 0:
					nible_hex='0';
					break;
				case 1:
					nible_hex='1';
					break;
				case 2:
					nible_hex='2';
					break;
				case 3:
					nible_hex='3';
					break;
				case 4:
					nible_hex='4';					
					break;
				case 5:
					nible_hex='5';
					break;
				case 6:
					nible_hex='6';
					break;
				case 7:
					nible_hex='7';
					break;
				case 8:
					nible_hex='8';
					break;
				case 9:
					nible_hex='9';
					break;
				case 10:
					nible_hex='A';
					break;
				case 11:
					nible_hex='B';
					break;
				case 12:
					nible_hex='C';
					break;
				case 13:
					nible_hex='D';
					break;
				case 14:
					nible_hex='E';
					break;
				case 15:
					nible_hex='F';
					break;
				default:
					nible_hex='0';
					break;
			};//switch			
			return nible_hex;

		}//NatToNibleHex


		//This function recives 2 char array with 2 Hexadecimal digits and returns its value.
		public int ByteHexToNat(char [] byte_hex ) {
			int byte_nat=0;
			
			byte_nat = NibleHexToNat(byte_hex[1]);//Lower weight digit is added to final value			
			byte_nat = byte_nat + 16*NibleHexToNat(byte_hex[0]);//Higher weight digit is added to final value
			return byte_nat;
		
		}//ByteHexToNat


		//This function recives 2 char array with 2 Hexadecimal digits and returns its ASCII representation in a char.
		public char ByteHexToASCII(char [] ByteHex ) {		
			int ByteNat=0;
			
			ByteNat = NibleHexToNat(ByteHex[1]);//Lower weight digit is added to final value			
			ByteNat = ByteNat + 16*NibleHexToNat(ByteHex[0]);//Higher weight digit is added to final value		
			return (char)ByteNat;
		
		}//ByteHexToNat

		
		//This function recives a natural and returns its hexadecimal byte 
		//representation, if it is greater than 255 or lower than 0, it's 
		//out of range and a default '00' hexadecimal byte is returned.
		public string NatToByteHex(int nat ) {		
			string aux_string="";
			int aux_int=0;

			if ((nat>255)||(nat<0)){
				//if it is out of natural byte range 00 is returned
				aux_string="00";
			}else{
				aux_int=nat / 16;//higher weitgh digit is calculated
				aux_string=aux_string+NatToNibleHex(aux_int).ToString();
				aux_int=nat % 16;//lower weitgh digit is calculated
				aux_string=aux_string+NatToNibleHex(aux_int).ToString();
			};//if
			return aux_string;
		
		}//ByteHexToNat
	
	
	}
}
